require "chigago_employees_ahsan/version"
require "unirest"

module ChigagoEmployeesAhsan
  class Employee
    attr_reader :title, :department, :name, :salary, :first_name, :last_name
    def initialize(input_options)
      @title = input_options['job_titles']
      @department = input_options['department']
      @name = input_options['name']
      @salary = input_options['annual_salary'].to_i
      @first_name = @name.split(', ')[1]
      @last_name = @name.split(', ')[0]

    end

    def self.all
      Unirest.get("https://data.cityofchicago.org/resource/tt4n-kn4t.json")
          .body
          .map{|employee| Employee.new(employee)}
    end

    def self.department(param_option)
      Unirest.get("https://data.cityofchicago.org/resource/tt4n-kn4t.json?department=#{param_option}")
          .body
          .map{|employee| Employee.new(employee)}
    end

    def self.highest_paid_three
      employee = Unirest.get("https://data.cityofchicago.org/resource/tt4n-kn4t.json")
          .body
          .map{|employee| Employee.new(employee)}
      employee.max_by(3){|employee| employee.salary}
    end
  end
end
